#vim: set filetype=py

#########################################################    generic python modules    #############################################

import os, sys
from string import *
from glob import glob

# uncomment the following statements for more verbose logging of the setup (and the sys.stdout restore after all imports)
sysStdOut = sys.stdout
#sys.stdout = open('/dev/null','w')

print("""
import os, sys
from string import *
from glob import glob""")

# uncomment the following block of three lines if you do not import numpy automatically
# (hint:  in ipython you can use the %pylab magic to automatically load numpy and matplotlib for interactive work)

# try:                      import numpy as np
# except ImportError, msg:  raise SystemExit (str(msg) + '\nimport numpy (numeric python) failed!')
# else:                     print "import numpy as np"

##############################################################    search path     ##################################################

# where are the sources?

if os.path.islink(__file__):
	py4cats_home = os.path.dirname(os.readlink(__file__))
else:
	py4cats_home = os.path.dirname(__file__)

print('\nsys.path[0]', sys.path[0])
print('__file__   ', __file__, '   a link?', os.path.islink(__file__))
print('py4catshome', py4cats_home, '   in sys.path?', py4cats_home in sys.path, '\n')

# adjust the Python search path and insert the Py4CAtS src file directory at its top
if os.path.isdir(py4cats_home):
	try:
		sys.path.insert (0, py4cats_home)
	except ImportError as msg:
		print('# WARNING:  adding py4cats to sys.path failed\n' + str(msg))
	else:
		print('# INFO: inserting py4cats src dir to sys.path', sys.path[0], '\n===> %i %s' % (len(sys.path), 'dirs'))
else:
	print('ERROR --- py4cats.py:   trying to setup py4cats, but the given path is non-existing/wrong/...')
	# why is the SystemExit not raised ???
	raise SystemExit ('%s\n%s%s\n%s' %
	                  ('ERROR --- py4cats.py:   trying to setup py4cats, but the given path is non-existing/wrong/...',
	                 '            (Check  py4cats_home = ', py4cats_home,
			 '             and/or correct "py4cats_home")'))


#########################################################   import important modules   #############################################
#  TODO:  make a package!

try:   from ir import amu, c, h, k, pi   # some fundamental constants, see  http://physics.nist.gov/cuu/Constants/
except ImportError as msg:  print('# WARNING:  import py4cats.ir module failed!\n' + str(msg))
else:  print("\nfrom ir import amu, c, h, k, pi")

try:   from aeiou import awrite, cstack, minmaxmean, grep_from_header, loadxy, loadxyy
except ImportError as msg: print('# WARNING:  import py4cats.aeiou  module failed!\n' + str(msg))
else:  print("from aeiou import awrite, cstack, minmaxmean, grep_from_header, loadxy, loadxyy")

try:   from struc_array import *
except ImportError as msg: print('# WARNING:  import py4cats.struc_array  module failed!\n' + str(msg))
else:  print("from struc_array import *")

try:   from pairTypes import Interval, PairOfInts, PairOfFloats
except ImportError as msg: print('# WARNING:  import py4cats.pairTypes  module failed!\n' + str(msg))
else:  print("from pairTypes import Interval")

try:   from moreFun import sindg, cosdg
except ImportError as msg: print('# WARNING:  import py4cats.moreFun  module failed!\n' + str(msg))
else:  print("from moreFun import sindg, cosdg")

try:   from misc import approx, monotone, regrid, runningAverage, trapez, xTruncate
except ImportError as msg: print('# WARNING:  import py4cats.misc  module failed!\n' + str(msg))
else:  print("from misc import approx, monotone, regrid, runningAverage, trapez, xTruncate")

try:   from grid import grid, parseGridSpec
except ImportError as msg: print('# WARNING:  import py4cats.grid  module failed!\n' + str(msg))
else:  print("from grid import grid, parseGridSpec")

try:   from higstract import *
except ImportError as msg: print('# WARNING:  import py4cats.higstract  module failed!\n' + str(msg))
else:  print("from higstract import *")

try:   from hitran import extract_hitran
except ImportError as msg: print('# WARNING:  import py4cats.hitran  module failed!\n' + str(msg))
else:  print("from hitran import extract_hitran")

try:   from geisa import extract_geisa
except ImportError as msg: print('# WARNING:  import py4cats.geisa  module failed!\n' + str(msg))
else:  print("from geisa import extract_geisa")

try:   from planck    import planck
except ImportError as msg: print('# WARNING:  import py4cats.planck module failed!\n' + str(msg))
else:  print("from planck    import planck")

try:   from cgsUnits  import cgs, unitConversion, lambda2nu, nu2lambda
except ImportError as msg: print('# WARNING:  import py4cats.cgsUnits module failed!\n' + str(msg))
else:  print("from cgsUnits  import cgs, unitConversion, lambda2nu, nu2lambda")

try:   from atmos1D import *
except ImportError as msg: print('# WARNING:  import py4cats.atmos1D module failed!\n' + str(msg))
else:  print("from atmos1D import *")

try:   from lines import atlas, read_line_file, delete_traceGasLines, voigt_parameters, meanLineWidths
except ImportError as msg: print('# WARNING:  import py4cats.lines module failed!\n' + str(msg))
else:  print("from lines import atlas, read_line_file, delete_traceGasLines, voigt_parameters, meanLineWidths")

try:   from lbl2xs import lbl2xs
except ImportError as msg: print('# WARNING:  import py4cats.lbl2xs module failed!\n' + str(msg))
else:  print("from lbl2xs import lbl2xs")

try:   from lbl2ac import lbl2ac
except ImportError as msg: print('# WARNING:  import py4cats.lbl2ac module failed!\n' + str(msg))
else:  print("from lbl2ac import *")

try:   from lbl2od import lbl2od
except ImportError as msg: print('# WARNING:  import py4cats.lbl2od module failed!\n' + str(msg))
else:  print("from lbl2od import lbl2od")

try:   from absCo import acArray, acPlot, acInfo, acSave, acRead
except ImportError as msg: print('# WARNING:  import py4cats.absCo module failed!\n' + str(msg))
else:  print("from absCo import *")

try:   from xs2od import xs2dod
except ImportError as msg: print('# WARNING:  import py4cats.xs2od module failed!\n' + str(msg))
else:  print("from xs2od import xs2dod")

try:   from xs2ac import xs2ac
except ImportError as msg: print('# WARNING:  import py4cats.xs2ac module failed!\n' + str(msg))
else:  print("from xs2ac import xs2ac")

try:   from ac2od import ac2dod
except ImportError as msg: print('# WARNING:  import py4cats.ac2od module failed!\n' + str(msg))
else:  print("from ac2od import ac2dod")

try:   from xSection import xsArray, xsRead, xsSave, xsPlot, xsInfo
except ImportError as msg: print('# WARNING:  import py4cats.xSection module failed!\n' + str(msg))
else:  print("from xSection import xsArray, xsRead, xsSave, xsPlot, xsInfo")

try:   from oDepth import *
except ImportError as msg: print('# WARNING:  import py4cats.oDepth module failed!\n' + str(msg))
else:  print("from oDepth import *")

try:   from ac2wf import *
except ImportError as msg: print('# WARNING:  import py4cats.ac2wf module failed!\n' + str(msg))
else:  print("from ac2wf import *")

try:   from wgtFct import wfPlot, wfSave, wfRead
except ImportError as msg: print('# WARNING:  import py4cats.wgtFct module failed!\n' + str(msg))
else:  print("from wgtFct import wfPlot, wfSave, wfRead")

try:   from od2ri import dod2ri
except ImportError as msg: print('# WARNING:  import py4cats.od2ri module failed!\n' + str(msg))
else:  print("from od2ri import dod2ri")

try:   from srf import srf, fts
except ImportError as msg: print('# WARNING:  import py4cats.srf module failed!\n' + str(msg))
else:  print("from srf import srf, fts")

try:   from convolution import convolveBox, convolveTriangle, convolveGauss
except ImportError as msg: print('# WARNING:  import py4cats.convolution module failed!\n' + str(msg))
else:  print("from convolution import convolveBox, convolveTriangle, convolveGauss")

try:   from radInt import riArray, riSave, riPlot, riRead
except ImportError as msg: print('# WARNING:  import py4cats.radInt module failed!\n' + str(msg))
else:  print("from radInt import riArray, riSave, riPlot, riRead")

try:   from radiance2Kelvin import radiance2Kelvin
except ImportError as msg: print('# WARNING:  import py4cats.radiance2Kelvin module failed!\n' + str(msg))
else:  print("from radiance2Kelvin import radiance2Kelvin")

try:   from radiance2radiance import radiance2radiance
except ImportError as msg: print('# WARNING:  import py4cats.radiance2radiance module failed!\n' + str(msg))
else:  print("from radiance2radiance import radiance2radiance")

if not sys.stdout=='stdout':  sys.stdout = sysStdOut  # restore standard output file object

print("\nINFO --- py4cats:  setup done\n",
      len(sys.path), "directories in sys.path, the very first should be Py4CAtS' home:\nsys.path[0] = ", sys.path[0])

#if not any([os.path.join('py4cats-lite','src') in sp for sp in sys.path]):
if not any([py4cats_home in sp for sp in sys.path]):
	print("\n%s %i\n%s %s %s\n%s" % ('WARNING:  len(sys.path) =', len(sys.path),
	      '          but no',repr(os.path.join('py4cats-lite','src')), 'in sys.path',
	      '          strange, trying to continue!?!'))


########################################################       matplotlib   ########################################################

# NOTE:   if you start Py4CAtS with the standard/classical Python interpreter or with IDLE
#         matplotlib / pyplot is NOT loaded automatically !!!
#         If you prefer the "classical" way, you might want to add some import statements here

# all defaults are now defined in ~/.config/matplotlib/matplotlibrc

def get_rcParams(what=None):
	""" Loop over all rcParams items and show all with `what` in the key. """
	if what:
		for key,val in list(rcParams.items()):
			if what in key:  print(key, val)
	else:  print(rcParams)

def landscape ():
	""" Swap figure size from portrait to landscape. """
	figWidth, figHeight = rcParams['figure.figsize']
	if figWidth<figHeight:  rcParams['figure.figsize'] = [figHeight,figWidth]

def portrait ():
	""" Swap figure size from landscape to portrait. """
	figWidth, figHeight = rcParams['figure.figsize']
	if figWidth>figHeight:  rcParams['figure.figsize'] = [figHeight,figWidth]

def toggle_orientation (orient=''):
	""" Swap figure size  landscape <---> portrait. """
	figWidth, figHeight = rcParams['figure.figsize']
	if   orient.lower().startswith('p') or orient=='|':
		rcParams['figure.figsize'] = [min(figWidth, figHeight),max(figWidth, figHeight)]
	elif orient.lower().startswith('l') or orient=='-':
		rcParams['figure.figsize'] = [max(figWidth, figHeight),min(figWidth, figHeight)]
	else:
		rcParams['figure.figsize'] = [figHeight,figWidth]

# if you do not like matplotlib's default key mappings, esp. for toggling linear <--> logarithmic axis, try/uncomment the following line
#rc('keymap', xscale='X', yscale='Y', quit='end')

# if you do not like matplotlib's color sequence, uncomment the following line (first colors correspond to the ACE/gr = Grace colors)
# (the first and second variants are historical)
#rc('axes', color_cycle='black red green blue yellow brown orange violet cyan magenta gray forestgreen gold maroon salmon firebrick darkblue pink orchid'.split())
#rc('axes', prop_cycle='black red green blue yellow brown orange violet cyan magenta gray forestgreen gold maroon salmon firebrick darkblue pink orchid'.split())
#rc('axes', prop_cycle=cycler('color','black red green blue yellow brown orange violet cyan magenta gray forestgreen gold maroon salmon firebrick darkblue pink orchid'.split()))

# if you do not like matplotlib's figure size, uncomment (and change) the following line
#rc('figure', figsize=(10.0,5.0))
#rc('figure.subplot', top=0.95, right=0.975, bottom=0.075, left=0.075, wspace=0.25)

# if you have started 'ipython qtconsole' and want to toggle between figures inside/outside:
# %matplotlib inline    # switch to inline  figures
# %matplotlib qt        # switch to outside figures
